# coding: utf-8


"""
IGNORE:
    Nutanix Lifecycle Management APIs

    Manage Infrastructure, Software and Firmware Upgrades.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_lifecycle_py_client.models.lifecycle.v4.common.EntityUpdateSpec import EntityUpdateSpec  # noqa: F401,E501
from ntnx_lifecycle_py_client.models.lifecycle.v4.common.ManagementServer import ManagementServer  # noqa: F401,E501
from ntnx_lifecycle_py_client.models.lifecycle.v4.common.SystemAutoMgmtFlag import SystemAutoMgmtFlag  # noqa: F401,E501

class PrechecksSpec(object):

    """Specification for running a Precheck operation.

    :param management_server: (:attr:`management_server`) 
    :type management_server: 
    
    
    :param entity_update_specs: (:attr:`entity_update_specs`) List of entity update objects for getting recommendations.
    :type entity_update_specs: required
    
    
    :param skipped_precheck_flags: (:attr:`skipped_precheck_flags`) List of prechecks to skip. The allowed value is 'powerOffUvms' that skips the pinned VM prechecks.
    :type skipped_precheck_flags: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'management_server': 'lifecycle.v4.common.ManagementServer',
        'entity_update_specs': 'list[lifecycle.v4.common.EntityUpdateSpec]',
        'skipped_precheck_flags': 'list[lifecycle.v4.common.SystemAutoMgmtFlag]',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'management_server': 'managementServer',
        'entity_update_specs': 'entityUpdateSpecs',
        'skipped_precheck_flags': 'skippedPrecheckFlags',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, management_server=None, entity_update_specs=None, skipped_precheck_flags=None, *args, **kwargs):  # noqa: E501
        self.__management_server = None
        self.__entity_update_specs = None
        self.__skipped_precheck_flags = None
        self.discriminator = None
        if management_server is not None:
            self.__management_server = management_server
        self.__entity_update_specs = entity_update_specs
        if skipped_precheck_flags is not None:
            self.__skipped_precheck_flags = skipped_precheck_flags
        # populate hidden vars if not empty
        self._populate_hidden_vars(kwargs)

    def _initialize_object_type(self):
        return 'lifecycle.v4.common.PrechecksSpec'

    def _initialize_object_version(self):
        return 'v4.r0'

    def _populate_hidden_vars(self, kwargs):
        if "_reserved" in kwargs and kwargs["_reserved"] is not None:
            self.__dollar_reserved = kwargs["_reserved"]
        elif hasattr(self, "attribute_map") and "_reserved" in self.attribute_map and self.attribute_map["_reserved"] in kwargs and kwargs[self.attribute_map["_reserved"]] is not None:
            self.__dollar_reserved = kwargs[self.attribute_map["_reserved"]]
        else :
            self.__dollar_reserved = {"$fv": self._initialize_object_version()}
        if "_unknown_fields" in kwargs and kwargs["_unknown_fields"] is not None:
            self.__dollar_unknown_fields = kwargs["_unknown_fields"]
        elif hasattr(self, "attribute_map") and "_unknown_fields" in self.attribute_map and self.attribute_map["_unknown_fields"] in kwargs and kwargs[self.attribute_map["_unknown_fields"]] is not None:
            self.__dollar_unknown_fields = kwargs[self.attribute_map["_unknown_fields"]]
        else :
            self.__dollar_unknown_fields = {}
        if "_object_type" in kwargs and kwargs["_object_type"] is not None:
            self.__dollar_object_type = kwargs["_object_type"]
        elif hasattr(self, "attribute_map") and "_object_type" in self.attribute_map and self.attribute_map["_object_type"] in kwargs and kwargs[self.attribute_map["_object_type"]] is not None:
            self.__dollar_object_type = kwargs[self.attribute_map["_object_type"]]
        else:
            self.__dollar_object_type = self._initialize_object_type()

    def get_object_type(self):
        return self.__dollar_object_type

    def get_reserved(self):
        return self.__dollar_reserved

    def get_unknown_fields(self):
        return self.__dollar_unknown_fields

    @property
    def management_server(self):
        """
        

        :type:
            :class:`~ntnx_lifecycle_py_client.models.lifecycle.v4.common.ManagementServer`
        """  # noqa: E501
        return self.__management_server

    @management_server.setter
    def management_server(self, management_server):

        self.__management_server = management_server

    @property
    def entity_update_specs(self):
        """
        List of entity update objects for getting recommendations.

        :type:
             list[ :class:`~ntnx_lifecycle_py_client.models.lifecycle.v4.common.EntityUpdateSpec` ]
        """  # noqa: E501
        return self.__entity_update_specs

    @entity_update_specs.setter
    def entity_update_specs(self, entity_update_specs):
        if entity_update_specs is None:
            raise ValueError("Invalid value for `entity_update_specs`, must not be `None`")  # noqa: E501

        self.__entity_update_specs = entity_update_specs

    @property
    def skipped_precheck_flags(self):
        """
        List of prechecks to skip. The allowed value is 'powerOffUvms' that skips the pinned VM prechecks.

        :type:
             list[ :class:`~ntnx_lifecycle_py_client.models.lifecycle.v4.common.SystemAutoMgmtFlag` ]
        """  # noqa: E501
        return self.__skipped_precheck_flags

    @skipped_precheck_flags.setter
    def skipped_precheck_flags(self, skipped_precheck_flags):

        self.__skipped_precheck_flags = skipped_precheck_flags

    @property
    def _reserved(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_reserved

    @property
    def _object_type(self):
        """
        

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__dollar_object_type

    @property
    def _unknown_fields(self):
        """
        

        :type:
            dict(str, :class:`~object`)
        """  # noqa: E501
        return self.__dollar_unknown_fields

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(PrechecksSpec, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, PrechecksSpec):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

