# coding: utf-8


"""
IGNORE:
    Nutanix Lifecycle Management APIs

    Manage Infrastructure, Software and Firmware Upgrades.  # noqa: E501

    OpenAPI spec version: 4.0.1
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
IGNORE
"""
import pprint
import json
import ast
import re  # noqa: F401

import six
from pathlib import Path
from ntnx_lifecycle_py_client.models.lifecycle.v4.common.EntityBaseModel import EntityBaseModel  # noqa: F401,E501
from ntnx_lifecycle_py_client.models.lifecycle.v4.common.EntityType import EntityType  # noqa: F401,E501
from ntnx_lifecycle_py_client.models.lifecycle.v4.common.EntityUpdateSpec import EntityUpdateSpec  # noqa: F401,E501

class DeployableVersion(EntityBaseModel):

    """List of deployable versions based on entity types, versions and its dependencies.

    :param target_version: (:attr:`target_version`) Entity target version.
    :type target_version: 
     min=1 chars, max=128 chars
    
    :param update_dependencies: (:attr:`update_dependencies`) 
    :type update_dependencies: 
    
    

    """
    """
    IGNORE:
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    IGNORE
    """  # noqa: E501
    swagger_types = {
        'target_version': 'str',
        'update_dependencies': 'list[lifecycle.v4.common.EntityUpdateSpec]',
        'entity_class': 'str',
        'entity_model': 'str',
        'entity_type': 'lifecycle.v4.common.EntityType',
        'entity_version': 'str',
        'hardware_family': 'str',
        'ext_id': 'str',
        'links': 'list[common.v1.response.ApiLink]',
        'tenant_id': 'str',
        '_reserved': 'dict(str, object)',
        '_object_type': 'str',
        '_unknown_fields': 'dict(str, object)',
    }

    attribute_map = {
        'target_version': 'targetVersion',
        'update_dependencies': 'updateDependencies',
        'entity_class': 'entityClass',
        'entity_model': 'entityModel',
        'entity_type': 'entityType',
        'entity_version': 'entityVersion',
        'hardware_family': 'hardwareFamily',
        'ext_id': 'extId',
        'links': 'links',
        'tenant_id': 'tenantId',
        '_reserved': '$reserved',
        '_object_type': '$objectType',
        '_unknown_fields': '$unknownFields',
    }



    def __init__(self, target_version=None, update_dependencies=None, entity_class=None, entity_model=None, entity_type=None, entity_version=None, hardware_family=None, ext_id=None, links=None, tenant_id=None, *args, **kwargs):  # noqa: E501
        EntityBaseModel.__init__(self, entity_class, entity_model, entity_type, entity_version, hardware_family, ext_id, links, tenant_id, *args, **kwargs)
        self.__target_version = None
        self.__update_dependencies = None
        self.discriminator = None
        if target_version is not None:
            self.__target_version = target_version
        if update_dependencies is not None:
            self.__update_dependencies = update_dependencies

    def _initialize_object_type(self):
        return 'lifecycle.v4.resources.DeployableVersion'

    def _initialize_object_version(self):
        return 'v4.r0'


    @property
    def target_version(self):
        """
        Entity target version.

        :type:
                :class:`~str`
        """  # noqa: E501
        return self.__target_version

    @target_version.setter
    def target_version(self, target_version):
        if target_version is not None and len(target_version) > 128:
            raise ValueError("Invalid value for `target_version`, length must be less than or equal to `128`")  # noqa: E501
        if target_version is not None and len(target_version) < 1:
            raise ValueError("Invalid value for `target_version`, length must be greater than or equal to `1`")  # noqa: E501

        self.__target_version = target_version

    @property
    def update_dependencies(self):
        """
        

        :type:
             list[ :class:`~ntnx_lifecycle_py_client.models.lifecycle.v4.common.EntityUpdateSpec` ]
        """  # noqa: E501
        return self.__update_dependencies

    @update_dependencies.setter
    def update_dependencies(self, update_dependencies):

        self.__update_dependencies = update_dependencies

    def _to_dict(self, sanitize):
        """Returns the model properties as a dict. Omits None properties based on the provided "sanitize" parameter.

        :param sanitize: A flag to omit None properties if set to True
        :type sanitize: bool
        """

        result = {}
        for attr, attr_type in six.iteritems(self.swagger_types):

            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x._to_dict(sanitize) if hasattr(x, "_to_dict") else x,
                    value
                ))
            elif hasattr(value, "_to_dict"):
                result[attr] = value._to_dict(sanitize)
            elif isinstance(value, Path):
                result[attr] = str(value)
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1]._to_dict(sanitize)) if hasattr(item[1], "_to_dict")
                    else (
                        (item[0], str(item[1])) if item[0] == 'path' and '$objectType' in value and value['$objectType'] == 'pathlib.Path'
                        else item
                    ),
                    six.iteritems(value)
                ))
            else:
                if sanitize:
                    if value is not None:
                        result[attr] = value
                else:
                    result[attr] = value
        if issubclass(DeployableVersion, dict):
            for key, value in six.iteritems(self):
                result[key] = value

        return result

    def to_dict(self):
        """Returns the model properties as a dictionary"""
        return self._to_dict(False)

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self._to_dict(True))

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, DeployableVersion):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other

